



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>利用ThreadLocal管理事务</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">利用ThreadLocal管理事务</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-20 00:10:07 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<pre class="prettyprint linenums">package com.itheima.util;

import java.sql.Connection;<br />
import java.sql.SQLException;<br />
//封装了所有与事务有关的方法<br />
public class TransactionManager {<br />
    private static ThreadLocal&lt;Connection&gt; tl = new ThreadLocal&lt;Connection&gt;();<br />
    public static Connection getConnection(){<br />
        Connection conn = tl.get();<br />
        if(conn==null){//从当前线程中获取链接<br />
            conn = DBCPUtil.getConnection();<br />
            tl.set(conn);<br />
        }<br />
        return conn;<br />
    }<br />
    public static void startTransaction(){<br />
        try {<br />
            Connection conn = getConnection();<br />
            conn.setAutoCommit(false);<br />
        } catch (SQLException e) {<br />
            e.printStackTrace();<br />
        }<br />
    }<br />
    public static void rollback(){<br />
        try {<br />
            Connection conn = getConnection();<br />
            conn.rollback();<br />
        } catch (SQLException e) {<br />
            e.printStackTrace();<br />
        }<br />
    }<br />
    public static void commit(){<br />
        try {<br />
            Connection conn = getConnection();<br />
            conn.commit();<br />
        } catch (SQLException e) {<br />
            e.printStackTrace();<br />
        }<br />
    }<br />
    public static void release(){<br />
        try {<br />
            Connection conn = getConnection();<br />
            conn.close();<br />
            tl.remove();//从当前线程中解绑。  与服务器实现有关：服务器采用线程池。<br />
        } catch (SQLException e) {<br />
            e.printStackTrace();<br />
        }<br />
    }<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49gpl0e9.html">编译CM13源码添加来去电归属地 SudaMod开源项目，查看commit提交记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mlk4p9.html">Linux -- objdump二进制文件比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8eg6mk9.html">基于PHP使用rabbitmq实现消息队列</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qykyrd9.html">python decorator simple example</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyknyg9.html">jQuery的ajax 方法提交多个对象数组问题 C&num; traditional &dollar;&period;param</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1mpre9.html">【Permutations】cpp</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w0n7vq.html">Elementary os的安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv725zq.html">代理模式及其在spring与struts2中的体现</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmwg109.html">魅蓝Note有几种颜色 魅蓝Note哪个颜色好看</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyemlz9.html">&lbrack;C&sol;C&plus;&plus;基础&rsqb;读写文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljw5le9.html">理解oracle中连接和会话</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjg0z28.html">201521123121 《Java程序设计》第9周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1jwdxq.html">JDBC操作数据库之连接数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1knox59.html">三：Linux 的基本命令、</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljd13e9.html">mysqldump 备份脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y1por8.html">一个小小的抽奖活动测试脚本（python2&period;7）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k7ep69.html">asp&period;net mvc 简单项目框架的搭建（二）&mdash;&mdash; Spring&period;Net在Mvc中的简单应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m6kjo8.html">Django---form表单提交数据到数据库（普通方法&plus;Django的form类）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jrdko8.html">Ubuntu 18&period;04安装MySQL指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j10md09.html">JAVA对mysql的基本操作</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93w6zknq.html">命令行方式安装Pycharm</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd4vxj9.html">手机上的m3u8视频（缓存）怎么转成MP4？</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w6ed0q.html">使用hint优化Oracle的运行计划 以及 SQL Tune Advisor的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2x37oq.html">【洛谷】【动态规划&sol;01背包】P2925 &lbrack;USACO08DEC&rsqb;干草出售Hay For Sale</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwxmv79.html">Hue添加MySQL数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w60xzq.html">WIN10 &plus; VS 2013 配置Opencv2&period;4&period;1&period;3  32位</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvz76z8.html">docker常用常用删除操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/960gjpj9.html">Java内存区域划分、内存分配原理&lpar;转&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wkozgq.html">MATLAB常用快捷键命令总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2nvvj9.html">深入浅出的webpack4构建工具---比mock模拟数据更简单的方式&lpar;二十一&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
